<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Winnie Hellmann">
  <meta name="dcterms.date" content="2019-10-25">
  <title>Game Development with Vue.js / Nuxt.js and Phaser</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="reveal.js/css/reveal.css">
  <style>
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <link rel="stylesheet" href="reveal.js/css/theme/white.css" id="theme">
  <link rel="stylesheet" href="style.css"/>
  <!-- Printing and PDF exports -->
  <script>
    var link = document.createElement( 'link' );
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = window.location.search.match( /print-pdf/gi ) ? 'reveal.js/css/print/pdf.css' : 'reveal.js/css/print/paper.css';
    document.getElementsByTagName( 'head' )[0].appendChild( link );
  </script>
  <!--[if lt IE 9]>
  <script src="reveal.js/lib/js/html5shiv.js"></script>
  <![endif]-->
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section id="title-slide">
  <h1 class="title">Game Development with <img data-src="img/vue-logo.png" alt="Vue.js" /> / <img data-src="img/nuxt-logo.svg" alt="Nuxt.js" /> and <img data-src="img/phaser-logo.gif" alt="Phaser" /></h1>
  <p class="author"><a href="https://gitlab.com/winh">Winnie Hellmann</a></p>
  <p class="date">2019-10-25</p>
</section>

<section id="frontend-engineer" class="slide level2">
<h2>Frontend Engineer</h2>
<p><a href="https://about.gitlab.com/"><img data-src="img/gitlab-logo.svg" alt="GitLab Logo" style="height: 50vh;" /></a></p>
</section>
<section id="whack-a-pipeline" class="slide level2" data-background-video="img/whack-a-pipeline.mp4" data-background-video-loop="true" data-background-size="contain">
<h2>Whack-a-Pipeline</h2>
</section>
<section id="entire-devops-cycle" class="slide level2" data-background-image="img/devops-cycle.png" data-background-size="90%">
<h2></h2>
</section>
<section><section id="why" class="title-slide slide level1"><h1>Why?</h1><p>…would you do that?</p>
<figure>
<img data-src="img/ponfused-carrot.png" alt="ponfused carrot" style="height: 7em; padding: 1em;" /><figcaption>ponfused carrot</figcaption>
</figure>
<p><small>picture by <a href="https://nathanfriend.io/">Nathan Friend</a></small></p></section><section id="why-browser-games" class="slide level2">
<h2>Why browser games? 🚿</h2>
<ul>
<li class="fragment">click and play
<ul>
<li class="fragment">good for game jams</li>
<li class="fragment">good to share with friends</li>
</ul></li>
<li class="fragment">powerful platform
<ul>
<li class="fragment">text rendering and alignment</li>
<li class="fragment">pre-defined UI components</li>
<li class="fragment">asset loading and caching built-in</li>
</ul></li>
<li class="fragment">developer tools</li>
<li class="fragment">simple update mechanism</li>
</ul>
</section><section id="why-phaser" class="slide level2">
<h2>Why <a href="https://phaser.io/">Phaser</a>? <img data-src="img/phaser-logo.gif" /></h2>
<ul>
<li class="fragment">MIT License</li>
<li class="fragment">parsers and renderers for
<ul>
<li class="fragment">tiled maps</li>
<li class="fragment">animated sprites</li>
</ul></li>
<li class="fragment">physics engines</li>
<li class="fragment">particle emitters</li>
<li class="fragment">2D / 3D cameras</li>
<li class="fragment">tweens</li>
<li class="fragment">very detailed documentation</li>
<li class="fragment">big collection of examples</li>
</ul>
</section><section id="why-vue.js" class="slide level2">
<h2>Why <a href="https://vuejs.org/">Vue.js</a>? <img data-src="img/vue-logo.png" style="height: 0.8em; padding: 0.1em;" /></h2>
<ul>
<li class="fragment">collocate HTML, CSS, JavaScript with <a href="https://vuejs.org/v2/guide/single-file-components.html">Single File Components</a></li>
<li class="fragment">extract / reuse components such as menus, modals, or overlays</li>
<li class="fragment"><a href="https://router.vuejs.org/">Vue Router</a> allows navigation between main menu, game, settings, …</li>
<li class="fragment"><a href="https://vuejs.org/v2/guide/reactivity.html">reactivity</a> allows to synchronize different components of the game</li>
</ul>
</section><section id="why-vuex" class="slide level2">
<h2>Why <a href="https://vuex.vuejs.org/">Vuex</a>? <img data-src="img/vue-logo.png" style="height: 0.8em; padding: 0.1em;" /></h2>
<ul>
<li class="fragment">official state management solution for Vue.js</li>
<li class="fragment">decouples components</li>
<li class="fragment">allows global application state</li>
<li class="fragment">makes business logic testable without rendering</li>
</ul>
</section></section>
<section><section id="what" class="title-slide slide level1"><h1>What?</h1><p>…can you do?</p>
<figure>
<img data-src="https://florentijnhofman.nl/sites/default/files/styles/frontpage-slick/public/home/_7ku9593.jpg?itok=UkOA-agh" alt="giant rubber duck" style="height: 9em;" /><figcaption>giant rubber duck</figcaption>
</figure>
<p><small>picture by <a href="https://florentijnhofman.nl">Florentijn Hofman</a></small></p></section><section id="game-entities-in-store" class="slide level2">
<h2>Game entities in store</h2>
<ul>
<li class="fragment"><p>actions to initialize and access entities</p></li>
<li class="fragment"><p>keep entities in local variables of store modules</p></li>
<li class="fragment"><p><strong>Disadvantages:</strong></p>
<ul>
<li class="fragment">each exposed Phaser method requires an action</li>
<li class="fragment">debug tools cannot easily access entities</li>
<li class="fragment">strong coupling of Phaser and store</li>
</ul></li>
</ul>
</section><section id="reactive-game-entities" class="slide level2">
<h2>Reactive game entities</h2>
<ul>
<li class="fragment"><p>overwrite properties of game entities with (derived) store state</p></li>
<li class="fragment"><p>actions/mutations update store</p></li>
<li class="fragment"><p>Phaser rendering picks up changes</p></li>
<li class="fragment"><p><strong>Disadvantages:</strong></p>
<ul>
<li class="fragment">only works for properties</li>
<li class="fragment">breaks if Phaser overwrites property</li>
<li class="fragment">property changes may cause performance problems</li>
</ul></li>
</ul>
</section><section id="store-watchers" class="slide level2">
<h2>Store watchers</h2>
<ul>
<li class="fragment"><p>game entities register watchers for relevant store state</p></li>
<li class="fragment"><p><strong>Disadvantages:</strong></p>
<ul>
<li class="fragment">potentially more verbose</li>
<li class="fragment">difficult to find all code that depends on certain state</li>
<li class="fragment">not possible to track events that don’t mutate state</li>
</ul></li>
</ul>
</section><section id="subscribe-action" class="slide level2">
<h2>Subscribe action</h2>
<ul>
<li class="fragment"><p>listener for dispatched store actions</p></li>
<li class="fragment"><p>triggers even if state remains same</p></li>
<li class="fragment"><p><strong>Disadvantages:</strong></p>
<ul>
<li class="fragment">hard to track when following data flow</li>
</ul></li>
</ul>
</section></section>
<section id="how" class="title-slide slide level1"><h1>How?</h1><p>…can you do it?</p>
<figure>
<img data-src="img/recipes.png" alt="drawing of recipes" style="height: 9em;" /><figcaption>drawing of recipes</figcaption>
</figure>
<p><small>picture by <a href="https://dasMaichen.de">dasMaichen</a></small></p></section>
<section><section id="yyhy" class="title-slide slide level1"><h1>Y<span style="margin-left: -0.1em"></span>Yhy?</h1><p>…is the carrot back?</p>
<figure>
<img data-src="img/ponfused-carrot.png" alt="ponfused carrot" style="height: 7em; padding: 1em;" /><figcaption>ponfused carrot</figcaption>
</figure>
<p><small>picture by <a href="https://nathanfriend.io/">Nathan Friend</a></small></p></section><section id="wrapper-components" class="slide level2">
<h2>Wrapper components?</h2>
<ul>
<li class="fragment">Vue follows the <a href="https://vuejs.org/v2/guide/components-props.html#One-Way-Data-Flow">One-Way Data Flow</a><br />
⇒ data to child components via reactive props</li>
<li class="fragment">Phaser objects are doubly linked<br />
⇒ Vue fails to recurse them</li>
<li class="fragment">some Phaser objects are updated often <small>(physics, tweens)</small><br />
⇒ performance problems</li>
<li class="fragment"><code>Object.freeze()</code> prevents reactivity<br />
…but also updating properties such as position</li>
</ul>
</section><section id="wrapper-components-1" class="slide level2">
<h2>Wrapper components?</h2>
<ul>
<li class="fragment">Vue components need single root DOM element<br />
…but Phaser renders to canvas</li>
<li class="fragment">workaround:<br />
create HTML comment using render function<br />
…but that does not allow child components</li>
<li class="fragment">workaround:<br />
a lot of <code>&lt;div&gt;</code>s</li>
</ul>
</section><section id="all-games" class="slide level2">
<h2>All games?</h2>
<ul>
<li class="fragment">avoid store actions for data that changes often <small>(for example position with physics)</small><br />
</li>
<li class="fragment">possible workarounds:
<ul>
<li class="fragment">debounce</li>
<li class="fragment">tile-based movement</li>
<li class="fragment">collision events</li>
</ul></li>
<li class="fragment">good fit: Adventure, Point And Click, Puzzle</li>
<li class="fragment">still ok: Jump ‘n’ Run</li>
<li class="fragment">bad fit: First-person shooter, Racing</li>
</ul>
</section><section id="links" class="slide level2">
<h2>Links</h2>
<ul>
<li class="fragment">real world examples:
<ul>
<li class="fragment"><a href="https://ldjam.com/events/ludum-dare/45/zwsp" class="uri">https://ldjam.com/events/ludum-dare/45/zwsp</a></li>
<li class="fragment"><a href="https://ldjam.com/events/ludum-dare/44/between-light-and-shadow" class="uri">https://ldjam.com/events/ludum-dare/44/between-light-and-shadow</a></li>
</ul></li>
<li class="fragment">slides: <a href="https://gitlab.com/winnie-slides/2019/nuxt-phaser-games-en" class="uri">https://gitlab.com/winnie-slides/2019/nuxt-phaser-games-en</a></li>
<li class="fragment">examples: <a href="https://gitlab.com/winnie-slides/2019/nuxt-phaser-games-examples" class="uri">https://gitlab.com/winnie-slides/2019/nuxt-phaser-games-examples</a></li>
</ul>
</section></section>
<section id="thanks-for-listening" class="title-slide slide level1"><h1>Thanks for listening! <br> <span style="display: inline-block; transform: scale(-1, 1);">👂</span>👀👂 <br> 🍿</h1></section>
    </div>
  </div>

  <script src="reveal.js/lib/js/head.min.js"></script>
  <script src="reveal.js/js/reveal.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://github.com/hakimel/reveal.js#configuration
      Reveal.initialize({
        // Push each slide change to the browser history
        history: true,
        // Transition style for full page slide backgrounds
        backgroundTransition: 'none', // none/fade/slide/convex/concave/zoom
        math: {
          mathjax: 'https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.2/MathJax.js',
          config: 'TeX-AMS_HTML-full',
          tex2jax: {
            inlineMath: [['\\(','\\)']],
            displayMath: [['\\[','\\]']],
            balanceBraces: true,
            processEscapes: false,
            processRefs: true,
            processEnvironments: true,
            preview: 'TeX',
            skipTags: ['script','noscript','style','textarea','pre','code'],
            ignoreClass: 'tex2jax_ignore',
            processClass: 'tex2jax_process'
          },
        },

        // Optional reveal.js plugins
        dependencies: [
          { src: 'reveal.js/lib/js/classList.js', condition: function() { return !document.body.classList; } },
          { src: 'reveal.js/plugin/zoom-js/zoom.js', async: true },
          { src: 'reveal.js/plugin/math/math.js', async: true },
          { src: 'reveal.js/plugin/notes/notes.js', async: true }
        ]
      });
    </script>
    </body>
</html>
